# Game of Life

The **Game of Life** by John Conway is a cellular automaton, where cells evolve over discrete time steps according to a set of simple rules. Each cell can be either **alive** or **dead** in the grid, and its state changes depending on the number of its neighbours.

Here are the rules of Conway's Game of Life:

> 1. **Any live cell with fewer than two live neighbours dies (underpopulation)**.
> 2. **Any live cell with two or three live neighbours lives on to the next generation**.
> 3. **Any live cell with more than three live neighbours dies (overpopulation)**.
> 4. **Any dead cell with exactly three live neighbours becomes a live cell (reproduction)**.

Key points:

> * The game is played on a 2D grid where each cell can be in one of two states: **alive** (1) or **dead** (0).
> * The grid is usually considered to have infinite size, but for practical purposes, it is often limited to a finite size.
> * The **neighbours** of a cell are the 8 cells surrounding it (in a 3x3 grid excluding the cell itself).

By appliying there simple rules, the configuration of the grid evolves over time, sometimes leading to interesting patterns like oscillators, gliders, or still lifes.
